require "./AI/USER_AI/prepare.lua"

require "./AI/USER_AI/Config.lua"
require "./AI/USER_AI/C_Check.lua"

require "./AI/USER_AI/subAI.lua"
require "./AI/USER_AI/GetEnemy.lua"
require "./AI/USER_AI/Atk_skl.lua"
-----------------------------
-- state(z̏Ԋ֐)
-----------------------------
IDLE_ST					= 0	-- ҋ@
FOLLOW_ST				= 1	-- ҒǏ]	
CHASE_ST				= 2	-- ^[QbgǐՏ
ATTACK_ST				= 3	-- U
--
-- (4A6`8A10`12́AŃzɐV@\ɎgꂻȂ̂ŎcĂ)
STOP_CMD_ST				= 5
HOLD_CMD_ST				= 9
--
RUNAWAY_ST				= 13	-- ǉ֐(S)
AUTO_PATROL_ST				= 14	-- G֐
LEAD_ENEMY_ST				= 15
-----------------------------
-----------------------------
-- global variableFݒ(AIxɍsݒ)
-----------------------------
MyState					= IDLE_ST	-- z̎̏Ԃ\(l͑ҋ@)
ResCmdList				= {}	-- \R}hXg
HomCondition				= MyState
BeforHomCondition			= MyState
-----------------------------
LEAD_ENEMYx	= 0
LEAD_ENEMYy	= 0
-----------------------------
-- Ot@Cǂݍ݊֌W̃O[oϐ
-----------------------------
-- ݒ
function	Start (myid)
	ResCmdList = List.new()

	CheckConfig()	-- Config.lua̐ݒ~XffAl݂̂ŕύX

	MyID = myid
	owner = GetV(V_OWNER, MyID)
	Mytype = GetV (V_HOMUNTYPE,MyID)
	MyDestX, MyDestY = GetV(V_POSITION,MyID)

	MyMaxHP = GetV (V_MAXHP,MyID)
	MyMaxSP = GetV (V_MAXSP,MyID)
	OwnerMaxHP = GetV (V_MAXHP,owner)
	dis = 0
	Timer1 = GetTick()
	Timer2 = GetTick()
	HealSP = GetV (V_SP,MyID)

	Guards,GuardsIndex = LoadIni(FILEPATH_GUARD)	-- hqǂݍ(}bvړŏȂ悤)
	lootmob,lootIndex = LoadIni(LootMob)
	Canceltype,Canceltype_Count = LoadIni(CANCELTYPE)
	NotAttack,NotAttack_Count = LoadIni(NOTATTACK)

	Guards = TableNumber(Guards)	-- e[u̓Y𐔎ɂ
	lootmob = TableNumber(lootmob)
	Canceltype = TableNumber(Canceltype)
	NotAttack = TableNumber(NotAttack)

	StartFlag = 1

	if (FarstState == 1) then
		MyState = FOLLOW_ST
		FOLLOWflag = 1
	elseif (FarstState == 0) then
		MyState = IDLE_ST
		FOLLOWflag = 0
	end
end
-----------------------------
-- C֐
-----------------------------
-----------------------------
function MainAI (myid)
	if StartFlag < 1 then
		Start (myid)	
	end

	-- G̃[VŨ`FbNA
	if (MyState == ATTACK_ST) then
		local enemymotion = GetV(V_MOTION, MyEnemy)
		if (enemymotion == MOTION_DAMAGED and true == IsInAttackSight(MyID,MyEnemy,MySkill)) then
			SucceedAttack = 1	-- łU(łe[VƂꂽ)
		end
	else
		SucceedAttack = 0
	end

	PrepareProcessCommand(myid)	-- 蓮R}h̏Ǝs

-- AI𓮂KvȂ߁Aŷ߂AȈsȂԊu(UȊO)
-- AI150msƂɎsĂ邽߁AQɈ񏈗s悤ɒAŖ300msԊuŏs
	local AITime = GetTick()
	local ExitEnemy = 0
	if (MyState ~= ATTACK_ST) then	-- 280
		if (280 > AITime - AI_Interval) then	-- xɂ덷z肵āA280ms𒴂ĂȂ܂TڂƂ݂Ȃreturn
			return
		end
		if ((MyState ~= IDLE_ST or MyState ~= STOP_CMD_ST) and 500 > AITime - AI_Interval) then	-- 0.5bƂɍWIDXV
			ExitEnemy = OnGetID () -- IDe[uXV
		elseif ((MyState == IDLE_ST or MyState == STOP_CMD_ST)) then
			ExitEnemy = OnGetID () -- IDe[uXV
		end
		if (1000 > AITime - AI_Interval) then	-- 1b𒴂Ăz̋L:"ɍU_ȃX^[":XV
			-- (iniXV)
			SaveIni(CANCELTYPE, Canceltype, "Canceltype_List")
			SaveIni(NOTATTACK, NotAttack, "Noattack_List")
		end
		AI_Interval = GetTick()
	end
	if (MyState == ATTACK_ST) then			-- U߂oxAÛݒPC̕Sy_Ă܂
 		if (AI_IDLE > 100 or AI_IDLE == nil) then	-- AI_IDLE100傫A܂nilȂ100ɋݒ
			AI_IDLE = 100
			for a = 0,AI_IDLE,1 do end	-- AI_IDLEŎw肵lɂȂ܂AI~߂
		else					-- AI_IDLE̒lȂ
			for a = 0,AI_IDLE,1 do end	-- AI_IDLEŎw肵lɂȂ܂AI~߂
		end
	end
	AutoCommand (myid,ExitEnemy)		--  
	if (MyState == ATTACK_ST and AttackMotionCancel == 1 and AttackCancelSwith == 1) then
		Attack (MyID,MyEnemy)
		AttackCancelSwith = 0
	end

	HealUseSP = GetV(V_SP,MyID)		-- [tpAq[sp̂i[

	-- G̃[VŨ`FbNA
	if (MyState == ATTACK_ST) then
		local enemymotion = GetV(V_MOTION, MyEnemy)
		if (enemymotion == MOTION_DAMAGED and true == IsInAttackSight(MyID,MyEnemy,MySkill)) then
			SucceedAttack = 1	-- łU(łe[VƂꂽ)
		end
	else
		SucceedAttack = 0
	end
end
--[[
[V`FbNƃZbg
G[VɂU̐ۂX^bNmEo݂
--]]
-- U͂ĂȂX^bN
function	stack()
	if (SucceedAttack == 0) then
		local Timer1 = GetTick()
		if (MoveDelay < Timer1) then
			MoveDelay = Timer1 + MoveTime
			SucceedAttackCount = SucceedAttackCount + 1
	-- G̔e[VmFłȂ܂ATTACK4sꂽ
			if (SucceedAttackCount > 3) then
				local x, y = GetV(V_POSITION,MyID)
				if (SucceedAttackCount == 4) then
					Move (MyID,x+1,y)
				elseif (SucceedAttackCount == 6) then
					Move (MyID,x-1,y)
				elseif (SucceedAttackCount == 8) then
					Move (MyID,x,y+1)
				elseif (SucceedAttackCount == 10) then
					Move (MyID,x,y-1)
				elseif (SucceedAttackCount > 12) then
					x,y = GetV(V_POSITION,owner)
					Move (MyID,x,y)
					SucceedAttackCount = 0
				end
				UsedSkill = 1
				TraceAI ("WXɂUsĂ܂(X^bN)")
			end
		end
	else
		SucceedAttackCount = 0
	end
	SucceedAttack = 0
end
-- ړ̃X^bN
function	movestack()
	local x, y = GetV(V_POSITION,MyID)
	local MyX, MyY, IDXY 
	IDXY = BeforDest[MyID]
	MyX = math.floor(IDXY / 1000)
	MyY = math.mod(IDXY,1000)
	if (x == MyX and y == MyY) then	-- ĂȂ
		local Timer1 = GetTick()
		if (MoveDelay < Timer1) then
			MoveDelay = Timer1 + MoveTime
			StackCount = StackCount + 1
			if (StackCount > 1) then
				if (StackCount == 2) then
					Move (MyID,x+1,y)
				elseif (StackCount == 3) then
					Move (MyID,x-1,y)
				elseif (StackCount == 4) then
					Move (MyID,x,y+1)
				elseif (StackCount == 5) then
					Move (MyID,x,y-1)
				elseif (StackCount > 5) then
					x,y = GetV(V_POSITION,owner)
					Move (MyID,x,y)
					StackCount = 0
				end
				UsedSkill = 1
				TraceAI ("WXɂړsĂ܂(X^bN)")
			end
		end
	else
		StackCount = 0
	end
end
-------------------------------------------------
-- Ql`h-Special thanks(Reference in development of AI)

-- The Winter's Tale
-- http://www.sgv417.jp/~winter/index.html

-- 0-MATERIAL (E܂Ă肠)
-- http://www.kogarashi.jp/0-material/

-- Ȟrev10
-- http://blog.livedoor.jp/aidev/archives/50119284.html

-- ܁`KAIt@Czz
-- http://www.kmzw.jp/nb/ai.html

-- UARwith[t
-- http://mmgguild.hp.infoseek.co.jp/

-- Glenelg
-- http://tomose.dynalias.net/RO/index.php?Top%20Page.

-- AIzzB
-- http://pc3merchant.net/ai/

-- Privatemoon
-- http://privatemoon.sakura.ne.jp/

-- RampageAI by Faithful
-- http://www.gorgerush.net/faithful/RampageAI/
-- (Reference@script is "ConfCheck.lua".)

-- The Winter's Tale
-- http://www.sgv417.jp/~winter/

-- ܁[̂Ԃ₫
-- http://merchant-murmur.info/

-- GvpAI by g37UcEp//g
-- http://gvai.blogzine.jp/gvai/

-- zNXpCuzz
-- http://himenomikoto.at.infoseek.co.jp/kulus_project/

-- zNXAIX@3
-- http://enif.mmobbs.com/test/read.cgi/livero/1142535070/l50

-- zNXAIX@4
-- http://enif.mmobbs.com/test/read.cgi/livero/1143193717/l50

-- zNXAIɂĂ̎GkEv]X
-- http://enif.mmobbs.com/test/read.cgi/livero/1142513331/l50

-- zNXAIɂĂ̎GkEv]X2
-- http://enif.mmobbs.com/test/read.cgi/livero/1146584661/l50

-- zNXAIɂĂ̎GkX 4
-- http://enif.mmobbs.com/test/read.cgi/livero/1161213721/l50

-------------------------------------------------
-----------------------------
--
-----------------------------
-- AȈ
function	AutoCommand (id,ExitEnemy)

	-- [VXV
	BeforHomMotion = HomMotion
	HomMotion = GetV(V_MOTION, MyID)

	BeforOwnerMotion = OwnerMotion
	OwnerMotion = GetV(V_MOTION, owner)

	-- bl[Vł葱邩(JEg1ɑ΂Ė0.3sAԂɂȂقǃYĂ)
	if (BeforOwnerMotion == OwnerMotion) then
		if (motioncount < 32) then	-- 10b(qǂ9b炢)
			motioncount = motioncount + 1		
		end
	else
		motioncount = 0
	end
	-- ԏ
	if (MyState == IDLE_ST) then	-- (FOLLOW_CMD):IDLE_ST:CHASE_ST:ATTACK_ST:RUNAWAY_ST->IDLE_ST
		HomState = MyState
		MyState, MyEnemy = OnIDLE_ST (MyState, MyEnemy,ExitEnemy)
	elseif (MyState == STOP_CMD_ST) then	-- (MOVE_CMD) -> STOP_CMD_ST
		HomState = MyState
		MyState, MyEnemy = OnSTOP_CMD_ST (MyState, MyEnemy,ExitEnemy)
	elseif (MyState == AUTO_PATROL_ST) then
		HomState = MyState
		MyState, MyEnemy = OnAUTO_PATROL_ST (MyState, MyEnemy,ExitEnemy)
	elseif (MyState == LEAD_ENEMY_ST) then	-- LeadEnemy() -> LEAD_ENEMY_ST
		HomState = MyState
		MyState, MyEnemy, LEAD_ENEMYx, LEAD_ENEMYy = OnLEAD_ENEMY_ST(MyState, MyEnemy, LEAD_ENEMYx, LEAD_ENEMYy)
		if (MyState ~= LEAD_ENEMY_ST) then
			LEAD_ENEMYx = 0
			LEAD_ENEMYy = 0
		end
	end
	if (MyState == FOLLOW_ST) then	-- (FOLLOW_CMD):IDLE_ST->FOLLOW_ST
		HomState = MyState
		MyState = OnFOLLOW_ST (MyState)
	elseif (MyState == CHASE_ST) then	-- (ATTACK_OBJECT_CMD:SKILL_OBJECT_CMD):IDLE_ST->CHASE_ST
		HomState = MyState
		MyState, MyEnemy,MySkillLevel,MySkill = OnCHASE_ST (MyState, MyEnemy,MySkillLevel,MySkill)
	elseif (MyState == HOLD_CMD_ST) then	-- STOP_CMD_ST->HOLD_CMD_ST
		HomState = MyState
		MyState, MyEnemy,MySkillLevel,MySkill = OnHOLD_CMD_ST (MyState, MyEnemy,MySkillLevel,MySkill)
	end
	if (MyState == ATTACK_ST) then	-- CHASE_ST->ATTACK_ST
		HomState = MyState
		MyState, MyEnemy,MySkillLevel,MySkill = OnATTACK_ST (MyState, MyEnemy,MySkillLevel,MySkill)
		MySkill = 0
	elseif (MyState == RUNAWAY_ST) then	-- CHASE_ST:ATTACK_ST->RUNAWAY_ST
		HomState = MyState
		MyState, MyEnemy,MySkillLevel,MySkill = OnRUNAWAY_ST (MyState, MyEnemy,MySkillLevel,MySkill)
	end
end
-----------------------------
--蓮R}h̏
-----------------------------
-- AI̎蓮̏
function	PrepareProcessCommand(id)
	local PrepareProcess = function(id)
		local cmd = List.popleft(ResCmdList)	-- R}he[u̍[߂o
		if (cmd ~= nil) then		
			ProcessCommand (cmd)	-- \R}h
		end
	end
	local msg	= GetMsg (id)			-- NCAg̃R}h𓾂
	local rmsg	= GetResMsg (id)		-- NCAg̗\R}h𓾂
	if (msg[1] == NONE_CMD) then						-- R}hꍇ
		if (rmsg[1] ~= NONE_CMD) then					-- ɗ\R}hꍇ
			if (List.size(ResCmdList) < 10) then		-- \R}h̃Xg̐10ȉȂ
				List.pushright (ResCmdList,rmsg)	-- R}he[ủE[Ɉǉ
			end
		end
		PrepareProcess(id)
	else								-- R}hꍇ
		List.clear (ResCmdList)					-- VR}h͂ꂽA\R}h͍폜
		ProcessCommand (msg)					-- R}hIDLEց\R}hCAII 
	end

	if (MyState == IDLE_ST) then
		PrepareProcess(id)
	end
end
-- AI̎蓮̏
function	ProcessCommand (msg)
	if	(msg[1] == MOVE_CMD) then -- (MyState -> STOP_CMD_ST)
		HomState = MyState
		MyState, MyEnemy = OnMOVE_CMD (msg[2],msg[3])		-- ړ{ߔԍ, XW, YW}
		MySkill = 0
	elseif	(msg[1] == ATTACK_OBJECT_CMD) then -- (MyState -> CHASE_ST)
		HomState = MyState
		MyState, MyEnemy = OnATTACK_OBJECT_CMD (msg[2])		-- U{ߔԍ, ڕWID}
	elseif	(msg[1] == SKILL_OBJECT_CMD) then -- (MyState -> CHASE_ST)
		HomState = MyState
		MyState, MyEnemy, MySkillLevel, MySkill = OnSKILL_OBJECT_CMD (msg[2],msg[3],msg[4])	-- ΏێwXLgp{ߔԍ, Ix, ,ڕWID}
	elseif	(msg[1] == FOLLOW_CMD) then -- (MyState -> FOLLOW_ST or IDLE_ST :by FOLLOWflag)
		HomState = MyState
		MyState, MyEnemy = OnFOLLOW_CMD ()				-- L҂ɒǏ]{ߔԍ}
	else
		New_CMD (msg)
	end
end
-- m̃R}hm点鏈
function	New_CMD (msg)
	TraceAI ("New_CMD")
	TableSave (msg,"NCAg疢m̃R}hn܂")
	EndAttack ()
end

-----------------------------
-- R}h͔F-**The step command is judged. 
-----------------------------
-----------------------------
function Command_ST ()
	local CommandX, CommandY = GetV (V_POSITION,MyID)

-- hqΏۓo^R}hp-**Character registration mode
	if (SafeGuard == 1) then	-- hq@\𗘗pꍇAo^\ɂȂ
		if (MyDestX == CommandX + 1 and MyDestY == CommandY + 1 and GuardSwitch == 0) then
			GuardSwitch = GuardSwitch + 1
		end
		if (MyDestX == CommandX + 1 and MyDestY == CommandY - 1 and GuardSwitch == 1) then
			GuardSwitch = GuardSwitch + 1
		end
		if (MyDestX == CommandX - 1 and MyDestY == CommandY - 1 and GuardSwitch == 2) then
			GuardSwitch = GuardSwitch + 1
		end
		if (MyDestX == CommandX - 1 and MyDestY == CommandY + 1 and GuardSwitch == 3) then
			local Ox, Oy = GetV (V_POSITION,owner)

			if (MyDestX+1 == Ox and MyDestY == Oy) then		-- ̎lƂȂɂ
		-- hqΏۂ̕ۑR}h
				if (GuardAdd == 1) then		-- ^b`o^[hON/OFF؂ւ
					GuardAdd = 0
				else
					GuardAdd = 1
				end
				MoveSE (MyID,MyDestX - 3,MyDestY)		-- 3Z
			end
			GuardSwitch = 0			-- ĂsĂtOZbg
			return
		end
	end
-- pg[R}hp-**[Patrol mode]
	if (MyDestX == CommandX + 1 and MyDestY == CommandY - 1 and PatrolSwitch == 0) then
		PatrolSwitch = PatrolSwitch + 1
	end
	if (MyDestX == CommandX + 1 and MyDestY == CommandY + 1 and PatrolSwitch == 1) then
		PatrolSwitch = PatrolSwitch + 1
	end
	if (MyDestX == CommandX - 1 and MyDestY == CommandY + 1 and PatrolSwitch == 2) then
		PatrolSwitch = PatrolSwitch + 1
	end
	if (MyDestX == CommandX - 1 and MyDestY == CommandY - 1 and PatrolSwitch == 3) then
		PatrolOn = 1

		MoveSE (MyID,MyDestX + 3,MyDestY)		-- E3Z
		PatrolSwitch = 0
		return
	end
end
-----------------------------
-- R}h̓LZ-**The mode by the step instruction judges whether to end. 
-----------------------------
-----------------------------
function CmdCancel ()
-- s̃R}htOZbgAR}hLZƔf

-- hqΏۓo^R}hp(o^͉R}hsĉ邽߁A[ĥ̂̃LZ͂ł͍sȂ)
	if(GuardSwitch ~= 0) then
		GuardSwitch = 0
	end
-- pg[R}hpA(o^͎loƉ)
	if(PatrolSwitch ~= 0) then
		PatrolSwitch = 0
	end

	if (OwnerMotion == MOTION_MOVE or OwnerMotion == MOTION_ATTACK or OwnerMotion == MOTION_ATTACK2) then	-- lړorU
		if(PatrolOn == 1) then
			PatrolOn = 0
		end
	end
end
-----------------------------
-- hq@\ɂLo^-**Character registration
-----------------------------
-----------------------------
-- ׂɋLGuardXgɒǉ
-- x,yɂOnMOVE_CMDmsg[2],msg[3]̒l
-----------------------------
function SetGuard (x, y)
	TraceAI ("SetGuard")
	local temp = 0
	local object = 0
	local fx = 0
	local fy = 0
	local Joint = {}
	local Index = 0
	local Now_XY ,PNowXY ,Mx , My, Px, Py
	Now_XY = NowDest[MyID]

	Mx = math.floor(Now_XY / 1000)
	My = math.mod(Now_XY,1000)

	for i,v in ipairs(PlayerTable) do		-- ׂĂ̓GȊOIDɑ΂
		PNowXY = NowDest[v]
		Px = math.floor(Now_XY / 1000)
		Py = math.mod(Now_XY,1000)
		if (Px == x and Py == y) then 
			object = v
				-- NbNWƃvC[̍WvꍇAǉɓ
		end
	end

	if (object ~= 0) then
		temp = GetGuard(object, Guards,0)	-- hqXgɂȂltemp
		if (temp ~= nil) then			-- ǉ
			AddSaveIni(FILEPATH_GUARD, temp, "GuardList")	-- Ot@Cɒǉ
			Guards = LoadIni(FILEPATH_GUARD)	-- ۑhqǂݍ
			Guards = TableNumber(Guards)	-- e[u̓Y𐔎ɂ

			MoveSE(MyID, Mx, My - 1)					--1
			CheckReset = 1
		else
			MoveSE(MyID, Mx - 1, My)					--NǉȂ1
			CheckReset = 1
		end
	end
end
-----------------------------
-- hqXgp̃f[^f-**Judgment whether add it
-----------------------------
--flag=1 XgɓĂIDAID̂܂ܕԂ
--flag=0 XgɓĂȂVKIDAID̂܂ܕԂ
function GetGuard(ActerId, Gdate, flag)
	local resultActors = 0
	local Index = 0
	local targetFlag = 0

	for i, GlistId in ipairs(Gdate) do
		if (ActerId == GlistId) then
			targetFlag = 1
		end
	end
	if (targetFlag == flag) then	-- VȗFBo^ꍇ
		resultActors = ActerId	-- FBe[uɒǉ
	end

	return resultActors				-- FBe[uԂ
end
-----------------------------
-- pg[̗Vړ̃[g
-- MyPatrolXMyPatrolYɒlAUTO_PATROL_STɖ߂
-----------------------------
-----------------------------
--[[
EConfig.lua Őݒł PPattern ̒lœ̕s

elseif (PPattern == )@ then
	ȉ

MyPatrolXMyPatrolY̒l`Ƃ̈ʒu֓Ă܂
Eł邮@\̏pƗlXȃp^[̃pg[\ɂȂ܂

EftHg2@\͔͈͓Ń_ړ鏈ł

EPPattern = 0F͈͓5`0Z_ړ
ړ̂D݂̕ɃIXX

EPPattern = 1F_ړ̂@qŁA
͈͓̃Z_w肷邽ߔ͈͂̒[ɂȂsƂ

EPPattern = 2@ȍ~F`AeōD݂ɍ킹ĒǉĂ
--]]
function	PatrolPattern(mystate)
	local x, y = GetV (V_POSITION,MyID)
	local ownerX, ownerY = GetV (V_POSITION,owner)
	local MyPatrolX, MyPatrolY = GetV (V_POSITION,MyID)
-- p^[0(0`5_ړ)
	if (PPattern == 0) then		-- **Pattern"0"
		-- l痣ꂷȂ悤ɁA@𐧌
		local distance = GetDistance2(MyID,owner)
		if ( distance > PatrolRange or distance == -1 or GetV(V_MOTION, owner) == MOTION_MOVE) then
			mystate = FOLLOW_ST
			TraceAI ("AUTO_PATROL_ST -> FOLLOW_ST")
			return mystate, MyPatrolX, MyPatrolY
		end
		local PDiceX1 = math.floor(math.random(5))
		local PDiceY1 = math.floor(math.random(5))
		local PDiceX2 = math.floor(math.random(5))
		local PDiceY2 = math.floor(math.random(5))
		if ((PDiceX1 - PDiceX2) ~= 0) then
			MyPatrolX = x + PDiceX1 - PDiceX2
		else
			PDiceX1 = math.floor(math.random(5))
			MyPatrolX = x + PDiceX1 - PDiceX2
		end
		if ((PDiceY1 - PDiceY2) ~= 0) then
			MyPatrolY = y + PDiceY1 - PDiceY2
		else
			PDiceY1 = math.floor(math.random(5))
			MyPatrolY = y + PDiceY1 - PDiceY2
		end
-- p^[1(Pȃ_ړ)
	elseif (PPattern == 1) then	-- **Pattern"1"
		MyPatrolX = ownerX + math.random((-1)*PatrolRange,PatrolRange)
		MyPatrolY = ownerY + math.random((-1)*PatrolRange,PatrolRange)
-- p^[2(2_ړ)
	elseif (PPattern == 2) then	-- **Pattern"2"
		-- l痣ꂷȂ悤ɁA@𐧌
		local distance = GetDistance2(MyID,owner)
		if ( distance > PatrolRange or distance == -1 or OwnerMotion == MOTION_MOVE) then
			mystate = FOLLOW_ST
			TraceAI ("AUTO_PATROL_ST -> FOLLOW_ST")
			return mystate, MyPatrolX, MyPatrolY
		end
		local PDiceX1 = math.floor(math.random(5))
		local PDiceY1 = math.floor(math.random(5))
		local PDiceX2 = math.floor(math.random(5))
		local PDiceY2 = math.floor(math.random(5))
		if ((PDiceX1 - PDiceX2) ~= 0) then
			if (0 < (PDiceX1 - PDiceX2)) then
				MyPatrolX = x + 2
			elseif (0 > (PDiceX1 - PDiceX2)) then
				MyPatrolX = x - 2
			end
		end
		if ((PDiceY1 - PDiceY2) ~= 0) then
			if (0 < (PDiceY1 - PDiceY2)) then
				MyPatrolY = y + 2
			elseif (0 > (PDiceY1 - PDiceY2)) then
				MyPatrolY = y - 2
			end
		end
-- `p^[
	else
		PPattern = 0
	end

	return mystate, MyPatrolX, MyPatrolY
end
----------------------------------------------------
-- g
----------------------------------------------------
--[[
fobN̂߂̃c[

AIgہAϐ̒gmF鎞Ɏgpĉ

EIdSave (id)
FidɓID̍WIDAHOMUNTYPE"Id.txt"ɏ܂

EDateSave (date, "dateǂȃf[^̊ȒPȐ")
FdateɓĂ钆g"File.txt"ɏ܂
 ' '̒ɐp̃ƒgƈꏏɂ̃oĂ܂

ETableSave (table, "tableǂȃf[^̊ȒPȐ")
Ftableɓe[u̒g"list.txt"ɏ܂
 " '̒ɕƒgƈꏏɕoĂ܂

ǵA
F
IdSave (v)@Ȃǂ̗l
֐́i@jɔCӂ̕ϐΊY鐔leLXgɓfĂ܂

܂ADateSaveTableSave
DateSave (v, "GID")
Ƃ悤""ň͂ɃRgƂ̃RgꏏɓfĂ܂
--]]

function IdSave (id)
 	local GX, GY = GetV (V_POSITION,id)
	if (id == nil) then id = "Nodate" end
	fp = FileOpen("AI/USER_AI/Id.txt", "a") -- USER_AItH_w肷邱ƁIi"a"͒ǉ݁j
	fp:write( string.format("check date\t%s\n", os.date("%Y/%m/%d %H:%M:%S")) ) -- L^
	fp:write( string.format("[ %s, %s ]\t%s\t=\t%s\n", GX, GY, id, GetV(V_HOMUNTYPE,id)) ) -- id̍WAidAidHOMUNTYPE
	fp:write("\n")
	fp:close()
end
function DateSave (date, section)
	if(section == nil) then section = "UnknowDate" end
	if (date == nil) then date = "Nodate" end

	fp = FileOpen("AI/USER_AI/File.txt", "a") -- USER_AItH_w肷邱ƁIi"a"͒ǉ݁j
  	fp:write( string.format("check date\t%s\n", os.date("%Y/%m/%d %H:%M:%S")) ) -- L^
	fp:write(string.format("\t%s = [%s]\n", date, section))
	fp:close()
end
function TableSave (table,section)
	if(section == nil) then section = "UnknowDate" end
	if (table == nil) then table[1] = "Nodate" end

	fp = FileOpen("AI/USER_AI/list.txt", "a") -- USER_AItH_w肷邱ƁIi"a"͒ǉ݁j
 	fp:write( string.format("check date\t%s\n", os.date("%Y/%m/%d %H:%M:%S")) ) -- L^

	fp:write(string.format("[%s]\n", section))
	for k, v in pairs(table) do
		fp:write(string.format("\t%s = %s\n", k, v))
	end
	fp:close()
end